<?php

namespace App\Http\Middleware;

use Closure;
use Illuminate\Http\Request;
use Symfony\Component\HttpFoundation\Response;

class RoleMiddleware
{
    /**
     * Handle an incoming request.
     */
    public function handle(Request $request, Closure $next, ...$roles): Response
    {
        // Ambil user dari session
        $user = session('user');

        // Jika belum login
        if (!$user) {
            return redirect()->route('login')
                ->with('error', 'Silakan login terlebih dahulu');
        }

        // Jika role tidak ada
        if (!isset($user['role'])) {
            abort(403, 'Role tidak ditemukan');
        }

        // Jika role tidak sesuai
        if (!in_array($user['role'], $roles)) {
            $role = $user['role'];
            if ($role === 'admin') {
                return redirect()->route('admin.dashboard')->with('error', 'Akses ditolak: Anda tidak memiliki izin untuk halaman tersebut.');
            } elseif ($role === 'superadmin') {
                return redirect()->route('admin.superadmin.dashboard')->with('error', 'Akses ditolak: Anda tidak memiliki izin untuk halaman tersebut.');
            } else {
                return redirect()->route('user.dashboard')->with('error', 'Akses ditolak: Anda tidak memiliki izin untuk halaman tersebut.');
            }
        }

        return $next($request);
    }
}
